--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/signal_restore.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,119 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Comptuer Company
+ */
+
+/*
+ * Verify that the FPU contents are correctly restored after taking a signal. We
+ * do this by going through and setting up a signal handler for SIGINFO and then
+ * we do the following as tightly as possible: overwriting the FPU contents and
+ * then calling thr_kill(). As part of the regression for #15254, we also
+ * purposefully go off CPU in the signal handler to try to wreak havoc.
+ */
+
+#include <err.h>
+#include <stdlib.h>
+#include <ucontext.h>
+#include <limits.h>
+#include <signal.h>
+#include <thread.h>
+#include <string.h>
+#include <time.h>
+#include <unistd.h>
+
+#include "xsave_util.h"
+
+static xsu_fpu_t init_vals, signal_vals, found;
+static volatile int exit_status = EXIT_SUCCESS;
+static volatile int took_sig = 0;
+static uint32_t sr_hwsup;
+
+static void
+signal_restore_siginfo(int sig, siginfo_t *sip, void *ucp)
+{
+	struct timespec ts;
+	took_sig = 1;
+
+	ts.tv_sec = 0;
+	ts.tv_nsec = 10 * MILLISEC;
+
+	/*
+	 * yield doesn't guarantee that we go off CPU, but try a few anyways.
+	 * There's a slight chance that nanosleep will modify the FPU state, but
+	 * we can hope we're lucky and that the libc function won'.
+	 */
+	xsu_setfpu(&signal_vals, sr_hwsup);
+	yield();
+	yield();
+	(void) nanosleep(&ts, NULL);
+	xsu_getfpu(&found, sr_hwsup);
+
+	if (xsu_same(&signal_vals, &found, sr_hwsup)) {
+		(void) printf("TEST PASSED: FPU contents didn't change in "
+		    "signal handler\n");
+	} else {
+		warnx("TEST FAILED: FPU contents changed in signal handler!");
+		exit_status = EXIT_FAILURE;
+	}
+
+}
+
+int
+main(void)
+{
+	int ret;
+	thread_t self = thr_self();
+	uint32_t start = arc4random();
+	uint32_t hwsup = xsu_hwsupport();
+	struct sigaction sa;
+
+	sr_hwsup = hwsup;
+	sa.sa_sigaction = signal_restore_siginfo;
+	sa.sa_flags = SA_RESETHAND;
+
+	if (sigaction(SIGINFO, &sa, NULL) != 0) {
+		errx(EXIT_FAILURE, "TEST FAILED: failed to set up signal "
+		    "handler");
+	}
+
+	(void) printf("filling starting at 0x%x\n", start);
+	xsu_fill(&init_vals, hwsup, start);
+	xsu_fill(&signal_vals, hwsup, start + INT_MAX);
+
+	(void) memset(&sa, 0, sizeof (struct sigaction));
+
+	xsu_setfpu(&init_vals, hwsup);
+	ret = thr_kill(self, SIGINFO);
+	xsu_getfpu(&found, hwsup);
+
+	if (ret != 0) {
+		errc(EXIT_FAILURE, ret, "TEST FAILED: failed to deliver "
+		    "signal");
+	}
+
+	if (took_sig == 0) {
+		errx(EXIT_FAILURE, "TEST FAILED: signal handler did not run");
+	}
+
+	(void) printf("TEST PASSED: SIGINFO successfully delivered\n");
+
+	if (xsu_same(&init_vals, &found, hwsup)) {
+		(void) printf("TEST PASSED: FPU contents successfully "
+		    "restored\n");
+	} else {
+		warnx("TEST FAILED: FPU contents were not restored!");
+		exit_status = EXIT_FAILURE;
+	}
+
+	return (exit_status);
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/swapcontext_extd.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,111 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * This test exercises the swapcontext_extd(2) functionality and verifies that
+ * we can swap contexts tht have both extended and non-extended ucontext_t's and
+ * that we can get at that state in both cases. This test relies on extended
+ * states as we try to validate and ensure that they exist.
+ */
+
+#include <err.h>
+#include <stdlib.h>
+#include <ucontext.h>
+#include <limits.h>
+#include <errno.h>
+
+#include "xsave_util.h"
+
+static xsu_fpu_t mk_fpu, orig_fpu, found;
+static ucontext_t *mk_ctx, *orig_ctx;
+static volatile int estatus = EXIT_SUCCESS;
+
+static void
+mkctx_target(uint32_t hwsup)
+{
+	xsu_getfpu(&found, hwsup);
+	if (!xsu_same(&mk_fpu, &found, hwsup)) {
+		estatus = EXIT_FAILURE;
+		warnx("TEST FAILED: initial swap had bad FPU");
+	} else {
+		(void) printf("TEST PASSED: initial swap had correct FPU\n");
+	}
+
+	(void) swapcontext_extd(mk_ctx, 0, orig_ctx);
+	err(EXIT_FAILURE, "swapcontext_extd() back failed");
+}
+
+static void
+mkctx_failure(void)
+{
+	errx(EXIT_FAILURE, "swapcontext_extd() called failure func");
+}
+
+int
+main(void)
+{
+	uint32_t hwsup = xsu_hwsupport();
+	uint32_t start = arc4random();
+
+	xsu_fill(&mk_fpu, hwsup, start);
+	xsu_fill(&orig_fpu, hwsup, start + INT_MAX);
+
+	mk_ctx = ucontext_alloc(0);
+	if (mk_ctx == NULL)
+		err(EXIT_FAILURE, "failed to allocate extended ucontext_t");
+	orig_ctx = ucontext_alloc(0);
+	if (orig_ctx == NULL)
+		err(EXIT_FAILURE, "failed to allocate extended ucontext_t");
+
+	/*
+	 * Set the FPU and snag our initial context. We'll use makecontext to
+	 * call this and then change our FPU, swap and start checking and then
+	 * swap back.
+	 */
+	xsu_setfpu(&mk_fpu, hwsup);
+	if (getcontext_extd(mk_ctx, 0) != 0) {
+		errx(EXIT_FAILURE, "failed to get initial extended context for "
+		    "makecontext");
+	}
+
+	makecontext(mk_ctx, mkctx_target, 1, hwsup);
+	xsu_setfpu(&orig_fpu, hwsup);
+	if (swapcontext_extd(orig_ctx, 0, mk_ctx) != 0) {
+		err(EXIT_FAILURE, "failed to swap contexts");
+	}
+	xsu_getfpu(&found, hwsup);
+	if (!xsu_same(&orig_fpu, &found, hwsup)) {
+		estatus = EXIT_FAILURE;
+		warnx("TEST FAILED: swap back did not have the right FPU");
+	} else {
+		(void) printf("TEST PASSED: swap back had the correct FPU\n");
+	}
+
+	makecontext(mk_ctx, mkctx_failure, 0);
+	if (swapcontext_extd(orig_ctx, 23, mk_ctx) != -1) {
+		errx(EXIT_FAILURE, "somehow got back from error test "
+		    "swapcontext_extd() with bad func");
+	}
+	if (errno != EINVAL) {
+		estatus = EXIT_FAILURE;
+		warnx("TEST FAILED: swapcontext_extd() with bad flags had "
+		    "errno %d expected EINVAL", errno);
+	} else {
+		(void) printf("TEST PASSED: swapcontext_extd() with bad flags "
+		    "has correct errno (EINVAL)\n");
+	}
+
+	return (estatus);
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/xregs_dump.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,50 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * This is a simple program that is meant for use as other programs consuming
+ * it. It simply reads the extended registers and dumps them. The expectation
+ * is someone else is showing up and doing something ahead of that.
+ */
+
+#include <err.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "xsave_util.h"
+
+static xsu_fpu_t fpu;
+
+int
+main(int argc, char *argv[])
+{
+	FILE *f;
+	uint32_t hwsup;
+
+	if (argc != 2) {
+		errx(EXIT_FAILURE, "missing required filename to write to");
+	}
+
+	hwsup = xsu_hwsupport();
+	f = fopen(argv[1], "w+");
+	if (f == NULL) {
+		err(EXIT_FAILURE, "failed to open %s", argv[1]);
+	}
+
+	xsu_getfpu(&fpu, hwsup);
+	xsu_dump(f, &fpu, hwsup);
+
+	return (EXIT_SUCCESS);
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/xregs_roundtrip.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,136 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * Verify that we can read the xregs of a thread and write them back intact.
+ * This uses libproc as a wrapper. We then start the thread running again and
+ * attempt to write to /proc ourselves to expect an EBUSY because the thread is
+ * not stopped.
+ */
+
+#include <libproc.h>
+#include <thread.h>
+#include <stdlib.h>
+#include <err.h>
+#include <errno.h>
+#include <string.h>
+#include <sys/sysmacros.h>
+
+#include "xsave_util.h"
+
+int
+main(void)
+{
+	int ret, fd;
+	ssize_t sret;
+	struct ps_prochandle *P;
+	struct ps_lwphandle *L;
+	thread_t targ;
+	prxregset_t *prx, *prx_alt;
+	size_t prx_len, prx_alt_len;
+	struct iovec iov[2];
+	long cmd = PCSXREG;
+
+	P = Pgrab(getpid(), PGRAB_RDONLY, &ret);
+	if (P == NULL) {
+		errx(EXIT_FAILURE, "failed to grab ourself: %s",
+		    Pgrab_error(ret));
+	}
+
+	ret = thr_create(NULL, 0, xsu_sleeper_thread, NULL, THR_DETACHED,
+	    &targ);
+	if (ret != 0) {
+		errc(EXIT_FAILURE, ret, "failed to create sleeper thread");
+	}
+
+	L = Lgrab(P, targ, &ret);
+	if (L == NULL) {
+		errx(EXIT_FAILURE, "failed to grab our sleeper thread: %s",
+		    Lgrab_error(ret));
+	}
+
+	ret = Lstop(L, 0);
+	if (ret != 0) {
+		err(EXIT_FAILURE, "failed to stop the sleeper thread");
+	}
+
+	if (Lgetxregs(L, &prx, &prx_len) != 0) {
+		err(EXIT_FAILURE, "failed to get xregs");
+	}
+
+	(void) printf("TEST PASSED: sucessfully got initial xregs\n");
+
+	if (Lsetxregs(L, prx, prx_len) != 0) {
+		err(EXIT_FAILURE, "failed to set xregs");
+	}
+
+	(void) printf("TEST PASSED: sucessfully set xregs\n");
+
+	if (Lgetxregs(L, &prx_alt, &prx_alt_len) != 0) {
+		err(EXIT_FAILURE, "failed to get xregs after write");
+	}
+
+	if (prx_len != prx_alt_len) {
+		errx(EXIT_FAILURE, "xreg length changed across a write: "
+		    "originally found %zu, now %zu", prx_len, prx_alt_len);
+	}
+
+	if (memcmp(prx, prx_alt, prx_len) != 0) {
+		const uint8_t *a = (uint8_t *)prx;
+		const uint8_t *b = (uint8_t *)prx_alt;
+		for (size_t i = 0; i < prx_len; i++) {
+			if (a[i] != b[i]) {
+				(void) fprintf(stderr, "prx[0x%x] = 0x%02x, "
+				    "prx_alt[0x%x] = 0x%02x\n", i, a[i], i,
+				    b[i]);
+			}
+		}
+		errx(EXIT_FAILURE, "xregs were not the same!");
+	}
+
+	(void) printf("TEST PASSED: round-trip xregs\n");
+
+	if (Lsetrun(L, 0, 0) != 0) {
+		err(EXIT_FAILURE, "failed to start sleeper thread");
+	}
+
+	/*
+	 * We write to /proc directly ourselves as a way to avoid libproc's own
+	 * checks for the state of the thread.
+	 */
+	fd = Lctlfd(L);
+	if (fd < 0) {
+		errx(EXIT_FAILURE, "failed to get sleeper thread control d");
+	}
+
+	iov[0].iov_base = (char *)&cmd;
+	iov[0].iov_len = sizeof (long);
+	iov[1].iov_base = (char *)prx;
+	iov[1].iov_len = prx_len;
+	sret = writev(fd, iov, ARRAY_SIZE(iov));
+	if (sret != -1) {
+		errx(EXIT_FAILURE, "writev returned %zd, but expected -1",
+		    sret);
+	}
+
+	if (errno != EBUSY) {
+
+	}
+
+	(void) printf("TEST PASSED: got EBUSY with PCSXREG to running "
+	    "thread\n");
+	Plwp_freexregs(P, prx, prx_len);
+	return (EXIT_SUCCESS);
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/xregs_set.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,58 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * This is a program that is meant to be used as a target for libproc and mdb.
+ * It uses a CLI-based seed and sets its FPU to a set of known values. After
+ * that, we call a function that can be used as a no-op target to dump the FPU
+ * state, attempting to minimize the number of instructions inbetween
+ * operations. We use the 'yield(2)' system call and library function in libc
+ * for that as it's something that'll not really do much and it is very unlikely
+ * the compiler will use the FPU between function calls.
+ */
+
+#include <err.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <errno.h>
+
+#include "xsave_util.h"
+
+static xsu_fpu_t fpu;
+
+int
+main(int argc, char *argv[])
+{
+	uint32_t hwsup;
+	char *eptr;
+	unsigned long ul;
+
+	if (argc != 2) {
+		errx(EXIT_FAILURE, "missing required seed");
+	}
+
+	errno = 0;
+	ul = strtoul(argv[1], &eptr, 0);
+	if (errno != 0 || *eptr != '\0') {
+		errx(EXIT_FAILURE, "seed value is bad: %s", argv[3]);
+	}
+
+	hwsup = xsu_hwsupport();
+	xsu_fill(&fpu, hwsup, (uint32_t)ul);
+	xsu_setfpu(&fpu, hwsup);
+
+	yield();
+	return (EXIT_SUCCESS);
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/xsave_asm32.S	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,169 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+	.file	"xsave_asm32.s"
+
+/*
+ * Test utility routines that we need assembler for. 32-bit addition.
+ */
+
+#include <sys/asm_linkage.h>
+#include "xsave_util.h"
+
+#define	GET_FPU_XMM(src, i)	\
+	leal	(i * XSU_ZMM_U32 * 4)(src), %eax; \
+	movdqu	%xmm##i, (%eax)
+
+#define	GET_FPU_YMM(src, i)	\
+	leal	(i * XSU_ZMM_U32 * 4)(src), %eax; \
+	vmovdqu	%ymm##i, (%eax)
+
+#define	GET_FPU_ZMM(src, i)	\
+	leal	(i * XSU_ZMM_U32 * 4)(src), %eax; \
+	vmovdqu64	%zmm##i, (%eax)
+
+#define	GET_MASK(src, i)	\
+	leal	(0x800 + i * 8)(src), %eax; \
+	kmovq	%k##i, (%eax)
+
+	/*
+	 * void xsu_getfpu(xsu_fpu_t *data, uint32_t type)
+	 *
+	 * Our job is to get the entire contents of the FPU and save it into our
+	 * data structure.
+	 */
+	ENTRY(xsu_getfpu)
+	movl	8(%esp), %eax
+	movl	4(%esp), %edx
+	cmpl	$XSU_XMM, %eax
+	je	get_xmm
+	cmpl	$XSU_YMM, %eax
+	je	get_ymm
+	cmpl	$XSU_ZMM, %eax
+	je	get_zmm
+	call	abort
+get_xmm:
+	GET_FPU_XMM(%edx, 0)
+	GET_FPU_XMM(%edx, 1)
+	GET_FPU_XMM(%edx, 2)
+	GET_FPU_XMM(%edx, 3)
+	GET_FPU_XMM(%edx, 4)
+	GET_FPU_XMM(%edx, 5)
+	GET_FPU_XMM(%edx, 6)
+	GET_FPU_XMM(%edx, 7)
+	jmp	get_done
+get_ymm:
+	GET_FPU_YMM(%edx, 0)
+	GET_FPU_YMM(%edx, 1)
+	GET_FPU_YMM(%edx, 2)
+	GET_FPU_YMM(%edx, 3)
+	GET_FPU_YMM(%edx, 4)
+	GET_FPU_YMM(%edx, 5)
+	GET_FPU_YMM(%edx, 6)
+	GET_FPU_YMM(%edx, 7)
+	jmp	get_done
+get_zmm:
+	GET_FPU_ZMM(%edx, 0)
+	GET_FPU_ZMM(%edx, 1)
+	GET_FPU_ZMM(%edx, 2)
+	GET_FPU_ZMM(%edx, 3)
+	GET_FPU_ZMM(%edx, 4)
+	GET_FPU_ZMM(%edx, 5)
+	GET_FPU_ZMM(%edx, 6)
+	GET_FPU_ZMM(%edx, 7)
+	GET_MASK(%edx, 0)
+	GET_MASK(%edx, 1)
+	GET_MASK(%edx, 2)
+	GET_MASK(%edx, 3)
+	GET_MASK(%edx, 4)
+	GET_MASK(%edx, 5)
+	GET_MASK(%edx, 6)
+	GET_MASK(%edx, 7)
+get_done:
+	ret
+	SET_SIZE(xsu_getfpu)
+
+#define	SET_FPU_XMM(src, i)	\
+	leal	(i * XSU_ZMM_U32 * 4)(src), %eax; \
+	movdqu	(%eax), %xmm##i
+
+#define	SET_FPU_YMM(src, i)	\
+	leal	(i * XSU_ZMM_U32 * 4)(src), %eax; \
+	vmovdqu	(%eax), %ymm##i
+
+#define	SET_FPU_ZMM(src, i)	\
+	leal	(i * XSU_ZMM_U32 * 4)(src), %eax; \
+	vmovdqu64	(%eax), %zmm##i
+
+#define	SET_MASK(src, i)	\
+	leal	(0x800 + i * 8)(src), %eax; \
+	kmovq	(%eax), %k##i
+
+	/*
+	 * void xsu_setfpu(const xsu_fpu_t *data, uint32_t type)
+	 *
+	 * Our job is to override the contents of the FPU with this structure
+	 * that we've been given. The type indicates how much of it to use.
+	 */
+	ENTRY(xsu_setfpu)
+	movl	8(%esp), %eax
+	movl	4(%esp), %edx
+	cmpl	$XSU_XMM, %eax
+	je	set_xmm
+	cmpl	$XSU_YMM, %eax
+	je	set_ymm
+	cmpl	$XSU_ZMM, %eax
+	je	set_zmm
+	call	abort
+set_xmm:
+	SET_FPU_XMM(%edx, 0)
+	SET_FPU_XMM(%edx, 1)
+	SET_FPU_XMM(%edx, 2)
+	SET_FPU_XMM(%edx, 3)
+	SET_FPU_XMM(%edx, 4)
+	SET_FPU_XMM(%edx, 5)
+	SET_FPU_XMM(%edx, 6)
+	SET_FPU_XMM(%edx, 7)
+	jmp	set_done
+set_ymm:
+	SET_FPU_YMM(%edx, 0)
+	SET_FPU_YMM(%edx, 1)
+	SET_FPU_YMM(%edx, 2)
+	SET_FPU_YMM(%edx, 3)
+	SET_FPU_YMM(%edx, 4)
+	SET_FPU_YMM(%edx, 5)
+	SET_FPU_YMM(%edx, 6)
+	SET_FPU_YMM(%edx, 7)
+	jmp	set_done
+set_zmm:
+	SET_FPU_ZMM(%edx, 0)
+	SET_FPU_ZMM(%edx, 1)
+	SET_FPU_ZMM(%edx, 2)
+	SET_FPU_ZMM(%edx, 3)
+	SET_FPU_ZMM(%edx, 4)
+	SET_FPU_ZMM(%edx, 5)
+	SET_FPU_ZMM(%edx, 6)
+	SET_FPU_ZMM(%edx, 7)
+	SET_MASK(%edx, 0)
+	SET_MASK(%edx, 1)
+	SET_MASK(%edx, 2)
+	SET_MASK(%edx, 3)
+	SET_MASK(%edx, 4)
+	SET_MASK(%edx, 5)
+	SET_MASK(%edx, 6)
+	SET_MASK(%edx, 7)
+set_done:
+	ret
+	SET_SIZE(xsu_setfpu)
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/xsave_asm64.S	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,247 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+	.file	"xsave_asm64.s"
+
+/*
+ * Test utility routines that we need assembler for. 64-bit addition.
+ */
+
+#include <sys/asm_linkage.h>
+#include "xsave_util.h"
+
+#define	GET_FPU_XMM(src, i)	\
+	leaq	(i * XSU_ZMM_U32 * 4)(src), %rax; \
+	movdqu	%xmm##i, (%rax)
+
+#define	GET_FPU_YMM(src, i)	\
+	leaq	(i * XSU_ZMM_U32 * 4)(src), %rax; \
+	vmovdqu	%ymm##i, (%rax)
+
+#define	GET_FPU_ZMM(src, i)	\
+	leaq	(i * XSU_ZMM_U32 * 4)(src), %rax; \
+	vmovdqu64	%zmm##i, (%rax)
+
+#define	GET_MASK(src, i)	\
+	leaq	(0x800 + i * 8)(src), %rax; \
+	kmovq	%k##i, (%rax)
+
+	/*
+	 * void xsu_getfpu(xsu_fpu_t *data, uint32_t type)
+	 *
+	 * Our job is to get the entire contents of the FPU and save it into our
+	 * data structure.
+	 */
+	ENTRY(xsu_getfpu)
+	cmpl	$XSU_XMM, %esi
+	je	get_xmm
+	cmpl	$XSU_YMM, %esi
+	je	get_ymm
+	cmpl	$XSU_ZMM, %esi
+	je	get_zmm
+	call	abort
+get_xmm:
+	GET_FPU_XMM(%rdi, 0)
+	GET_FPU_XMM(%rdi, 1)
+	GET_FPU_XMM(%rdi, 2)
+	GET_FPU_XMM(%rdi, 3)
+	GET_FPU_XMM(%rdi, 4)
+	GET_FPU_XMM(%rdi, 5)
+	GET_FPU_XMM(%rdi, 6)
+	GET_FPU_XMM(%rdi, 7)
+	GET_FPU_XMM(%rdi, 8)
+	GET_FPU_XMM(%rdi, 9)
+	GET_FPU_XMM(%rdi, 10)
+	GET_FPU_XMM(%rdi, 11)
+	GET_FPU_XMM(%rdi, 12)
+	GET_FPU_XMM(%rdi, 13)
+	GET_FPU_XMM(%rdi, 14)
+	GET_FPU_XMM(%rdi, 15)
+	jmp	get_done
+get_ymm:
+	GET_FPU_YMM(%rdi, 0)
+	GET_FPU_YMM(%rdi, 1)
+	GET_FPU_YMM(%rdi, 2)
+	GET_FPU_YMM(%rdi, 3)
+	GET_FPU_YMM(%rdi, 4)
+	GET_FPU_YMM(%rdi, 5)
+	GET_FPU_YMM(%rdi, 6)
+	GET_FPU_YMM(%rdi, 7)
+	GET_FPU_YMM(%rdi, 8)
+	GET_FPU_YMM(%rdi, 9)
+	GET_FPU_YMM(%rdi, 10)
+	GET_FPU_YMM(%rdi, 11)
+	GET_FPU_YMM(%rdi, 12)
+	GET_FPU_YMM(%rdi, 13)
+	GET_FPU_YMM(%rdi, 14)
+	GET_FPU_YMM(%rdi, 15)
+	jmp	get_done
+get_zmm:
+	GET_FPU_ZMM(%rdi, 0)
+	GET_FPU_ZMM(%rdi, 1)
+	GET_FPU_ZMM(%rdi, 2)
+	GET_FPU_ZMM(%rdi, 3)
+	GET_FPU_ZMM(%rdi, 4)
+	GET_FPU_ZMM(%rdi, 5)
+	GET_FPU_ZMM(%rdi, 6)
+	GET_FPU_ZMM(%rdi, 7)
+	GET_FPU_ZMM(%rdi, 8)
+	GET_FPU_ZMM(%rdi, 9)
+	GET_FPU_ZMM(%rdi, 10)
+	GET_FPU_ZMM(%rdi, 11)
+	GET_FPU_ZMM(%rdi, 12)
+	GET_FPU_ZMM(%rdi, 13)
+	GET_FPU_ZMM(%rdi, 14)
+	GET_FPU_ZMM(%rdi, 15)
+	GET_FPU_ZMM(%rdi, 16)
+	GET_FPU_ZMM(%rdi, 17)
+	GET_FPU_ZMM(%rdi, 18)
+	GET_FPU_ZMM(%rdi, 19)
+	GET_FPU_ZMM(%rdi, 20)
+	GET_FPU_ZMM(%rdi, 21)
+	GET_FPU_ZMM(%rdi, 22)
+	GET_FPU_ZMM(%rdi, 23)
+	GET_FPU_ZMM(%rdi, 24)
+	GET_FPU_ZMM(%rdi, 25)
+	GET_FPU_ZMM(%rdi, 25)
+	GET_FPU_ZMM(%rdi, 26)
+	GET_FPU_ZMM(%rdi, 27)
+	GET_FPU_ZMM(%rdi, 28)
+	GET_FPU_ZMM(%rdi, 29)
+	GET_FPU_ZMM(%rdi, 30)
+	GET_FPU_ZMM(%rdi, 31)
+	GET_MASK(%rdi, 0)
+	GET_MASK(%rdi, 1)
+	GET_MASK(%rdi, 2)
+	GET_MASK(%rdi, 3)
+	GET_MASK(%rdi, 4)
+	GET_MASK(%rdi, 5)
+	GET_MASK(%rdi, 6)
+	GET_MASK(%rdi, 7)
+get_done:
+	ret
+	SET_SIZE(xsu_getfpu)
+
+#define	SET_FPU_XMM(src, i)	\
+	leaq	(i * XSU_ZMM_U32 * 4)(src), %rax; \
+	movdqu	(%rax), %xmm##i
+
+#define	SET_FPU_YMM(src, i)	\
+	leaq	(i * XSU_ZMM_U32 * 4)(src), %rax; \
+	vmovdqu	(%rax), %ymm##i
+
+#define	SET_FPU_ZMM(src, i)	\
+	leaq	(i * XSU_ZMM_U32 * 4)(src), %rax; \
+	vmovdqu64	(%rax), %zmm##i
+
+#define	SET_MASK(src, i)	\
+	leaq	(0x800 + i * 8)(src), %rax; \
+	kmovq	(%rax), %k##i
+
+	/*
+	 * void xsu_setfpu(const xsu_fpu_t *data, uint32_t type)
+	 *
+	 * Our job is to override the contents of the FPU with this structure
+	 * that we've been given. The type indicates how much of it to use.
+	 */
+	ENTRY(xsu_setfpu)
+	cmpl	$XSU_XMM, %esi
+	je	set_xmm
+	cmpl	$XSU_YMM, %esi
+	je	set_ymm
+	cmpl	$XSU_ZMM, %esi
+	je	set_zmm
+	call	abort
+set_xmm:
+	SET_FPU_XMM(%rdi, 0)
+	SET_FPU_XMM(%rdi, 1)
+	SET_FPU_XMM(%rdi, 2)
+	SET_FPU_XMM(%rdi, 3)
+	SET_FPU_XMM(%rdi, 4)
+	SET_FPU_XMM(%rdi, 5)
+	SET_FPU_XMM(%rdi, 6)
+	SET_FPU_XMM(%rdi, 7)
+	SET_FPU_XMM(%rdi, 8)
+	SET_FPU_XMM(%rdi, 9)
+	SET_FPU_XMM(%rdi, 10)
+	SET_FPU_XMM(%rdi, 11)
+	SET_FPU_XMM(%rdi, 12)
+	SET_FPU_XMM(%rdi, 13)
+	SET_FPU_XMM(%rdi, 14)
+	SET_FPU_XMM(%rdi, 15)
+	jmp	set_done
+set_ymm:
+	SET_FPU_YMM(%rdi, 0)
+	SET_FPU_YMM(%rdi, 1)
+	SET_FPU_YMM(%rdi, 2)
+	SET_FPU_YMM(%rdi, 3)
+	SET_FPU_YMM(%rdi, 4)
+	SET_FPU_YMM(%rdi, 5)
+	SET_FPU_YMM(%rdi, 6)
+	SET_FPU_YMM(%rdi, 7)
+	SET_FPU_YMM(%rdi, 8)
+	SET_FPU_YMM(%rdi, 9)
+	SET_FPU_YMM(%rdi, 10)
+	SET_FPU_YMM(%rdi, 11)
+	SET_FPU_YMM(%rdi, 12)
+	SET_FPU_YMM(%rdi, 13)
+	SET_FPU_YMM(%rdi, 14)
+	SET_FPU_YMM(%rdi, 15)
+	jmp	set_done
+set_zmm:
+	SET_FPU_ZMM(%rdi, 0)
+	SET_FPU_ZMM(%rdi, 1)
+	SET_FPU_ZMM(%rdi, 2)
+	SET_FPU_ZMM(%rdi, 3)
+	SET_FPU_ZMM(%rdi, 4)
+	SET_FPU_ZMM(%rdi, 5)
+	SET_FPU_ZMM(%rdi, 6)
+	SET_FPU_ZMM(%rdi, 7)
+	SET_FPU_ZMM(%rdi, 8)
+	SET_FPU_ZMM(%rdi, 9)
+	SET_FPU_ZMM(%rdi, 10)
+	SET_FPU_ZMM(%rdi, 11)
+	SET_FPU_ZMM(%rdi, 12)
+	SET_FPU_ZMM(%rdi, 13)
+	SET_FPU_ZMM(%rdi, 14)
+	SET_FPU_ZMM(%rdi, 15)
+	SET_FPU_ZMM(%rdi, 16)
+	SET_FPU_ZMM(%rdi, 17)
+	SET_FPU_ZMM(%rdi, 18)
+	SET_FPU_ZMM(%rdi, 19)
+	SET_FPU_ZMM(%rdi, 20)
+	SET_FPU_ZMM(%rdi, 21)
+	SET_FPU_ZMM(%rdi, 22)
+	SET_FPU_ZMM(%rdi, 23)
+	SET_FPU_ZMM(%rdi, 24)
+	SET_FPU_ZMM(%rdi, 25)
+	SET_FPU_ZMM(%rdi, 25)
+	SET_FPU_ZMM(%rdi, 26)
+	SET_FPU_ZMM(%rdi, 27)
+	SET_FPU_ZMM(%rdi, 28)
+	SET_FPU_ZMM(%rdi, 29)
+	SET_FPU_ZMM(%rdi, 30)
+	SET_FPU_ZMM(%rdi, 31)
+	SET_MASK(%rdi, 0)
+	SET_MASK(%rdi, 1)
+	SET_MASK(%rdi, 2)
+	SET_MASK(%rdi, 3)
+	SET_MASK(%rdi, 4)
+	SET_MASK(%rdi, 5)
+	SET_MASK(%rdi, 6)
+	SET_MASK(%rdi, 7)
+set_done:
+	ret
+	SET_SIZE(xsu_setfpu)
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/xsave_baducontext.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,251 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * The purpose of this test is to go through and construct ucontext_t xsave
+ * states that we expect to be invalid and therefore cause setcontext(2) to
+ * fail. We only assume that %ymm state is present here with respect to writing
+ * invalid tests. As if this test runs at all, that will be present.
+ *
+ * This is structured a little differently as we expect this program to fail to
+ * execute and that libc will cause us to abort() if we don't correctly return
+ * from setcontext..
+ */
+
+#include <ucontext.h>
+#include <err.h>
+#include <stdlib.h>
+#include <strings.h>
+#include <errno.h>
+#include <sys/sysmacros.h>
+#include <sys/debug.h>
+#include <sys/x86_archext.h>
+#include <sys/mman.h>
+#include <unistd.h>
+
+#include "xsave_util.h"
+
+static void *xsave_buf;
+static const char *curtest;
+
+static void
+bad_success(void)
+{
+	errx(EXIT_FAILURE, "TEST FAILED: %s setcontext, took us to success",
+	    curtest);
+}
+
+static void
+test_bad_version(ucontext_t *ctx)
+{
+	uc_xsave_t *xc = (uc_xsave_t *)ctx->uc_xsave;
+	xc->ucx_vers = 23;
+}
+
+static void
+test_bad_length_small(ucontext_t *ctx)
+{
+	uc_xsave_t *xc = (uc_xsave_t *)ctx->uc_xsave;
+	xc->ucx_len = 0;
+}
+
+static void
+test_bad_length_large(ucontext_t *ctx)
+{
+	uc_xsave_t *xc = (uc_xsave_t *)ctx->uc_xsave;
+	xc->ucx_len = INT32_MAX;
+}
+
+/*
+ * As this can run on multiple different systems, we explicitly use bit 8 which
+ * is reserved for a supervisor feature and so should never be valid in this
+ * context.
+ */
+static void
+test_bad_vector(ucontext_t *ctx)
+{
+	uc_xsave_t *xc = (uc_xsave_t *)ctx->uc_xsave;
+	xc->ucx_bv |= (1 << 8);
+}
+
+static void
+test_context_too_short(ucontext_t *ctx)
+{
+	uc_xsave_t *xc = (uc_xsave_t *)ctx->uc_xsave;
+
+	bcopy(xc, xsave_buf, xc->ucx_len);
+	ctx->uc_xsave = (long)(uintptr_t)xsave_buf;
+	xc = (uc_xsave_t *)ctx->uc_xsave;
+	xc->ucx_bv |= XFEATURE_AVX;
+	xc->ucx_len = sizeof (uc_xsave_t) + 0x10;
+}
+
+static void
+test_context_badptr0(ucontext_t *ctx)
+{
+	ctx->uc_xsave = 0;
+}
+
+static void
+test_context_badptr1(ucontext_t *ctx)
+{
+	void *addr = mmap(NULL, sysconf(_SC_PAGESIZE), PROT_NONE,
+	    MAP_PRIVATE | MAP_ANON, -1, 0);
+	if (addr == NULL) {
+		err(EXIT_FAILURE, "failed to get unmapped page");
+	}
+
+	ctx->uc_xsave = (long)(uintptr_t)addr;
+}
+
+static void
+test_context_badptr2(ucontext_t *ctx)
+{
+	long pgsz = sysconf(_SC_PAGESIZE);
+	void *addr = mmap(NULL, pgsz * 2, PROT_NONE, MAP_PRIVATE | MAP_ANON,
+	    -1, 0);
+	if (addr == NULL) {
+		errx(EXIT_FAILURE, "failed to get unmapped page");
+	}
+
+	if (mprotect((void *)((uintptr_t)addr + pgsz), pgsz, PROT_NONE) != 0) {
+		err(EXIT_FAILURE, "failed to mprotect second page");
+	}
+
+	ctx->uc_xsave = (uintptr_t)addr;
+	ctx->uc_xsave += pgsz - sizeof (uint64_t);
+}
+
+static ucontext_t *
+setup_context(void)
+{
+	ucontext_t *ctx = ucontext_alloc(0);
+	if (ctx == NULL) {
+		errx(EXIT_FAILURE, "failed to get allocate ucontext_t");
+	}
+
+	if (getcontext_extd(ctx, 0) != 0) {
+		err(EXIT_FAILURE, "failed to get extended context");
+	}
+	makecontext(ctx, bad_success, 0);
+
+	return (ctx);
+}
+
+typedef struct {
+	void (*bct_func)(ucontext_t *);
+	const char *bct_test;
+	int bct_errno;
+} bad_ucontext_test_t;
+
+/*
+ * Do not use single quote characters in tests below, that'll break the shell
+ * wrapper.
+ */
+static const bad_ucontext_test_t tests[] = {
+	{ test_bad_version, "invalid version", EINVAL },
+	{ test_bad_length_small, "invalid length (small)", EINVAL },
+	{ test_bad_length_large, "invalid length (large)", EINVAL },
+	{ test_bad_vector, "invalid xbv", EINVAL },
+	{ test_context_too_short, "length does not cover AVX", EOVERFLOW },
+	{ test_context_badptr0, "invalid uc_xsave pointer (NULL)", EINVAL },
+	{ test_context_badptr1, "invalid uc_xsave pointer (unmapped page)",
+	    EFAULT },
+	{ test_context_badptr2, "partially invalid uc_xsave (hit "
+	    "unmapped page)", EFAULT },
+};
+
+int
+main(int argc, char *argv[])
+{
+	int c;
+	char *eptr;
+	unsigned long l;
+	const char *testno = NULL;
+	boolean_t do_info = B_FALSE, do_run = B_FALSE;
+
+	if (argc < 2) {
+		(void) fprintf(stderr, "Usage:  %s [-c] [-i testno] "
+		    "[-r testno]\n", argv[0]);
+	}
+
+	while ((c = getopt(argc, argv, ":ci:r:")) != -1) {
+		switch (c) {
+		case 'c':
+			(void) printf("%zu\n", ARRAY_SIZE(tests));
+			return (0);
+		case 'i':
+			testno = optarg;
+			do_info = B_TRUE;
+			break;
+		case 'r':
+			testno = optarg;
+			do_run = B_TRUE;
+			break;
+		case ':':
+			errx(EXIT_FAILURE, "Option -%c requires an operand\n",
+			    optopt);
+			break;
+		case '?':
+			errx(EXIT_FAILURE, "Unknown option: -%c\n", optopt);
+			break;
+		}
+	}
+
+	if (testno == NULL) {
+		errx(EXIT_FAILURE, "one of -r and -i must be specified");
+	}
+
+	if (do_run && do_info) {
+		errx(EXIT_FAILURE, "only one of -r and -i may be specified");
+	}
+
+	errno = 0;
+	l = strtoul(testno, &eptr, 0);
+	if (*eptr != 0 || errno != 0) {
+		errx(EXIT_FAILURE, "failed to parse test number: %s", argv[1]);
+	}
+
+	if (l >= ARRAY_SIZE(tests)) {
+		errx(EXIT_FAILURE, "test number %lu is too large\n", l);
+	}
+
+	if (do_info) {
+		/*
+		 * Output info for our wrapper shell script in a way that's not
+		 * too bad to eval.
+		 */
+		(void) printf("errno=%u\ndesc='%s'\n", tests[l].bct_errno,
+		    tests[l].bct_test);
+		return (0);
+	}
+
+	/*
+	 * This is a little gross, but we know right now that the extended
+	 * context is going to be the approximate size that we need for
+	 * operations on the system.
+	 */
+	xsave_buf = ucontext_alloc(0);
+	if (xsave_buf == NULL) {
+		err(EXIT_FAILURE, "failed to alternative xsave buf");
+	}
+
+	ucontext_t *ctx = setup_context();
+	VERIFY3U(ctx->uc_xsave, !=, 0);
+	tests[l].bct_func(ctx);
+	(void) setcontext(ctx);
+	errx(EXIT_FAILURE, "TEST FAILED: setcontext returned despite us "
+	    "expecting a core");
+}
